import 'codemirror/mode/javascript/javascript';
import 'codemirror/lib/codemirror.css';
import './style.css';
import { SylApi } from '@syllepsis/adapter';
import { Node as ProseMirrorNode } from 'prosemirror-model';
import { EditorView } from 'prosemirror-view';
declare type GetPos = () => number;
declare class CodeBlockView {
    dom: HTMLElement;
    private node;
    private view;
    private getPos;
    private incomingChanges;
    private cm;
    private updating;
    private templ;
    private editor;
    constructor(editor: SylApi, node: ProseMirrorNode, view: EditorView, getPos: boolean | GetPos);
    private boundEvent;
    private checkEditable;
    private forwardSelection;
    private asProseMirrorSelection;
    setSelection(anchor: number, head: number): void;
    private valueChanged;
    private codeMirrorKeymap;
    private maybeEscape;
    updateTemplValue(): void;
    update(node: ProseMirrorNode): boolean;
    selectNode(): void;
    stopEvent(): boolean;
    destroy(): void;
}
export { CodeBlockView };
