import { SylApi, SylController } from '@syllepsis/adapter';
import { EditorConfiguration } from 'codemirror';
import { ICodeBlockProps } from './config';
declare module '@syllepsis/adapter' {
    interface ISylApiCommand {
        code_block?: {
            setCodeBlock: (mode?: string) => void;
            clearCodeBlock: () => void;
        };
    }
}
declare class CodeBlockController extends SylController<ICodeBlockProps> {
    name: string;
    toolbar: {
        className: string;
        tooltip: string;
        handler: (editor: SylApi) => void;
    };
    command: {
        setCodeBlock: (editor: SylApi, mode?: EditorConfiguration['mode']) => void;
        clearCodeBlock: (editor: SylApi) => void;
    };
    keymap: {
        Backspace: (editor: SylApi, state: SylApi['view']['state'], dispatch: SylApi['view']['dispatch']) => boolean;
    };
    constructor(editor: SylApi, props: ICodeBlockProps);
}
export { CodeBlockController };
