var __vite_style__ = document.createElement("style");
__vite_style__.innerHTML = ".syl-editor .CodeMirror {\n  height: auto;\n  padding: 16px;\n  background: #fafafa;\n  border: 1px solid #e8e8e8;\n  font-size: 14px;\n  line-height: 22px;\n  font-family: Monaco;\n  color: #222;\n}\n\n.syl-editor .CodeMirror-linenumber {\n  padding-left: 0;\n  padding-right: 12px;\n  background-color: #fafafa;\n  color: #cacaca;\n  text-align: right;\n  line-height: 26px;\n  margin-top: -1px;\n}\n\n.syl-editor .CodeMirror-gutters {\n  background-color: #fafafa;\n  border-right: none;\n}\n\n.syl-editor .cm-s-default .cm-keyword {\n  color: #114ba6;\n}\n\n.syl-editor .cm-s-default .cm-atom {\n  color: #219;\n}\n\n.syl-editor .cm-s-default .cm-number {\n  color: #561a99;\n}\n\n.syl-editor .cm-s-default .cm-def {\n  color: #a82e2e;\n}\n\n.syl-editor .cm-s-default .cm-type {\n  color: #114ba6;\n}\n\n.syl-editor .cm-s-default .cm-comment {\n  color: #00753b;\n}\n\n.syl-editor .cm-s-default .cm-string {\n  color: #a82e2e;\n}\n\n.syl-editor .cm-s-default .cm-tag {\n  color: #a82e2e;\n}\n\n.syl-editor .cm-s-default .cm-attribute {\n  color: #00753b;\n}\n";
document.head.appendChild(__vite_style__);
(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(require("@syllepsis/adapter"), require("prosemirror-state"), require("codemirror/lib/codemirror.css"), require("codemirror/mode/javascript/javascript"), require("codemirror"), require("lodash.debounce"), require("prosemirror-commands")) : typeof define === "function" && define.amd ? define(["@syllepsis/adapter", "prosemirror-state", "codemirror/lib/codemirror.css", "codemirror/mode/javascript/javascript", "codemirror", "lodash.debounce", "prosemirror-commands"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global.adapter, global.prosemirrorState, null, null, global.CodeMirror, global.debounce, global.prosemirrorCommands));
})(this, function(adapter, prosemirrorState, codemirror_css, javascript, CodeMirror, debounce, prosemirrorCommands) {
  "use strict";
  function _interopDefaultLegacy(e) {
    return e && typeof e === "object" && "default" in e ? e : { "default": e };
  }
  var CodeMirror__default = /* @__PURE__ */ _interopDefaultLegacy(CodeMirror);
  var debounce__default = /* @__PURE__ */ _interopDefaultLegacy(debounce);
  var config = {};
  var setConfig = function(customConfig) {
    return config = Object.assign(config, customConfig);
  };
  var PLUGIN_NAME = "code_block";
  var __extends$2 = function() {
    var extendStatics = function(d, b) {
      extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
        d2.__proto__ = b2;
      } || function(d2, b2) {
        for (var p in b2)
          if (Object.prototype.hasOwnProperty.call(b2, p))
            d2[p] = b2[p];
      };
      return extendStatics(d, b);
    };
    return function(d, b) {
      if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  }();
  var WRAP = String.fromCharCode(10);
  var setCodeBlock = function(editor, language) {
    var _a = editor.view, state = _a.state, dispatch = _a.dispatch;
    var schema = state.schema, selection = state.selection, doc = state.doc;
    var from = selection.from, to = selection.to, $from = selection.$from;
    var selectTextLen = doc.textBetween(from, to, WRAP).length;
    var tr = state.tr;
    var codeText = "";
    var start;
    var end;
    doc.nodesBetween(from, to, function(node, pos) {
      if (node.isTextblock) {
        if (start === void 0) {
          start = pos;
        }
        end = pos + node.nodeSize;
        node.content.forEach(function(child) {
          if (child.isText)
            codeText += child.textContent;
          if (child.type.name === "break")
            codeText += WRAP;
        });
        codeText += WRAP;
        return false;
      }
    });
    codeText = codeText.substring(0, codeText.length - 1);
    if (start === void 0 || end === void 0)
      return;
    var newCode = schema.nodes.code_block.create(language ? { language } : void 0, codeText ? schema.text(codeText) : void 0);
    var $start = editor.view.state.doc.resolve(start);
    var $end = editor.view.state.doc.resolve(end);
    var newFrom = from;
    if ($start.depth && $start.indexAfter()) {
      newFrom += $start.depth;
    } else {
      newFrom -= $from.depth - 1;
    }
    if ($start.depth && !$start.indexAfter()) {
      start = $start.pos - $start.depth;
    }
    if ($end.depth && $end.indexAfter() === $end.parent.childCount) {
      end = $end.pos + $end.depth;
    }
    tr = tr.replaceRangeWith(start, end, newCode);
    dispatch(tr.setSelection(prosemirrorState.TextSelection.create(tr.doc, newFrom, newFrom + selectTextLen)));
    editor.focus();
  };
  var clearCodeBlock = function(editor) {
    var _a = editor.view, dispatch = _a.dispatch, state = _a.state;
    var schema = state.schema, tr = state.tr, selection = state.selection;
    var $from = selection.$from, $to = selection.$to;
    var node = $from.node();
    var nodePos = $from.before();
    var textContents = node.textContent.split(WRAP);
    var fragments = textContents.reduce(function(res, text) {
      if (text) {
        res.push(schema.text(text));
      }
      res.push(schema.nodes.break.create());
      return res;
    }, []);
    fragments.pop();
    dispatch(tr.replaceRangeWith(nodePos, nodePos + node.nodeSize, schema.nodes.paragraph.create(void 0, fragments)).setSelection(prosemirrorState.TextSelection.create(tr.doc, $from.pos, $to.pos)));
    editor.focus();
  };
  var CodeBlockController = function(_super) {
    __extends$2(CodeBlockController2, _super);
    function CodeBlockController2(editor, props) {
      var _this = _super.call(this, editor, props) || this;
      _this.name = PLUGIN_NAME;
      _this.toolbar = {
        className: PLUGIN_NAME,
        tooltip: PLUGIN_NAME,
        handler: function(editor2) {
          var $from = editor2.view.state.selection.$from;
          if ($from.parent.type.name === PLUGIN_NAME) {
            _this.command.clearCodeBlock(editor2);
          } else {
            _this.command.setCodeBlock(editor2, _this.props.mode);
          }
        }
      };
      _this.command = {
        setCodeBlock: function(editor2, mode) {
          setCodeBlock(editor2, mode || _this.props.mode);
          _this.props.afterInsert && _this.props.afterInsert(editor2);
        },
        clearCodeBlock: function(editor2) {
          clearCodeBlock(editor2);
        }
      };
      _this.keymap = {
        Backspace: function(editor2, state, dispatch) {
          var _a = state.selection, $from = _a.$from, empty = _a.empty;
          if (!empty || $from.nodeBefore)
            return false;
          var beforePos = $from.before();
          var prevNode = state.doc.resolve(beforePos).nodeBefore;
          if (!prevNode || prevNode.type.name !== PLUGIN_NAME || prevNode.childCount)
            return false;
          dispatch(state.tr.join(beforePos));
          return true;
        }
      };
      setConfig(props);
      return _this;
    }
    return CodeBlockController2;
  }(adapter.SylController);
  var fixCodeString = function(code) {
    return code.replace(/&nbsp;/g, " ").replace(/</g, "&lt;").replace(/>/g, "&gt;");
  };
  var DEFAULT_LANGUAGE = "javascript";
  var transformToShow = function(iLanguage) {
    var language = iLanguage.split(/[-,]/).filter(Boolean).join("");
    if (language === "js") {
      language = "javascript";
    }
    return language;
  };
  var removeEmptyCodeBlock = function(view, code) {
    var state = view.state, dispatch = view.dispatch;
    var selection = state.selection;
    if (code.getValue().trim() || !selection.empty || selection.$from !== selection.$to) {
      return false;
    }
    var $pos = selection.$from;
    var parent = $pos.node();
    if ($pos.start() !== $pos.pos || !parent.type.spec.code) {
      return false;
    }
    var type = !$pos.node(-1) && $pos.node(-1) !== state.schema.nodes.doc ? $pos.node(-1).type : state.schema.nodes.paragraph;
    var tr = state.tr.setNodeMarkup($pos.before(), type);
    dispatch(tr);
    return true;
  };
  var style = "";
  var __assign = function() {
    __assign = Object.assign || function(t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s)
          if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
      }
      return t;
    };
    return __assign.apply(this, arguments);
  };
  var CodeBlockView = function() {
    function CodeBlockView2(editor, node, view, getPos) {
      var _this = this;
      this.boundEvent = function() {
        _this.cm.on("beforeChange", function() {
          return _this.incomingChanges = true;
        });
        _this.cm.on("cursorActivity", function() {
          if (!_this.updating && !_this.incomingChanges)
            _this.forwardSelection();
        });
        _this.cm.on("changes", function() {
          if (!_this.updating) {
            _this.valueChanged();
            _this.forwardSelection();
          }
          _this.incomingChanges = false;
        });
        _this.cm.on("focus", _this.forwardSelection);
        _this.editor.on(adapter.EventChannel.LocalEvent.ON_CHANGE, _this.checkEditable);
      };
      this.checkEditable = debounce__default["default"](function() {
        if (_this.editor.editable && _this.cm.isReadOnly()) {
          _this.cm.setOption("readOnly", false);
        } else if (!_this.editor.editable && !_this.cm.isReadOnly()) {
          _this.cm.setOption("readOnly", "nocursor");
        }
      }, 300, { leading: true });
      this.forwardSelection = function() {
        if (!_this.cm.hasFocus())
          return;
        var state = _this.view.state;
        var selection = _this.asProseMirrorSelection(state.doc);
        if (!selection.eq(state.selection)) {
          _this.view.dispatch(state.tr.setSelection(selection));
        }
      };
      this.node = node;
      this.view = view;
      this.getPos = getPos;
      this.editor = editor;
      this.incomingChanges = false;
      this.dom = adapter.createCardDOM();
      var maskDOM = adapter.createMaskDOM();
      this.templ = adapter.createTemplDOM();
      this.dom.appendChild(this.templ);
      this.dom.appendChild(maskDOM);
      this.cm = CodeMirror__default["default"](maskDOM, __assign({ value: this.node.textContent, tabSize: 2, mode: node.attrs.language || DEFAULT_LANGUAGE, extraKeys: this.codeMirrorKeymap(editor) }, config));
      this.boundEvent();
      this.updateTemplValue();
      setTimeout(function() {
        return _this.cm.refresh();
      }, 20);
      this.updating = false;
      this.dom.setAttribute("language", node.attrs.language);
      this.dom.setAttribute("code_block", "true");
    }
    CodeBlockView2.prototype.asProseMirrorSelection = function(doc) {
      var offset = this.getPos() + 1;
      var anchor = this.cm.indexFromPos(this.cm.getCursor("from")) + offset;
      var head = this.cm.indexFromPos(this.cm.getCursor("to")) + offset;
      return prosemirrorState.TextSelection.create(doc, anchor, head);
    };
    CodeBlockView2.prototype.setSelection = function(anchor, head) {
      this.updating = true;
      this.cm.setSelection(this.cm.posFromIndex(anchor), this.cm.posFromIndex(head));
      if (!this.cm.hasFocus())
        this.cm.focus();
      this.updating = false;
    };
    CodeBlockView2.prototype.valueChanged = function() {
      var change = computeChange(this.node.textContent, this.cm.getValue());
      if (change) {
        var start = this.getPos() + 1;
        var tr = this.view.state.tr.replaceWith(start + change.from, start + change.to, change.text ? this.view.state.schema.text(change.text) : null);
        this.updateTemplValue();
        this.view.dispatch(tr);
      }
    };
    CodeBlockView2.prototype.codeMirrorKeymap = function(editor) {
      var _a;
      var _this = this;
      var view = editor.view;
      var cm = function() {
        return _this.cm;
      };
      var mod = /Mac/.test(navigator.platform) ? "Cmd" : "Ctrl";
      var undo = function() {
        editor.undo();
        editor.focus();
      };
      var redo = function() {
        editor.redo();
        editor.focus();
      };
      return CodeMirror__default["default"].normalizeKeyMap((_a = {
        Up: function() {
          return _this.maybeEscape("line", -1);
        },
        Left: function() {
          return _this.maybeEscape("char", -1);
        },
        Down: function() {
          return _this.maybeEscape("line", 1);
        },
        Right: function() {
          return _this.maybeEscape("char", 1);
        }
      }, _a[mod + "-Z"] = undo, _a["Shift-" + mod + "-Z"] = redo, _a[mod + "-Y"] = redo, _a[mod + "-Enter"] = function() {
        if (prosemirrorCommands.exitCode(view.state, view.dispatch))
          view.focus();
      }, _a.Enter = function() {
        var _cm = cm();
        var lineCount = _cm.lineCount();
        var cursorLine = _cm.getCursor().line;
        if (lineCount > 1 && cursorLine === lineCount - 1) {
          var curLine = _cm.getLine(cursorLine);
          if (curLine === "") {
            var prevLine = _cm.getLine(cursorLine - 1);
            if (prevLine === "") {
              _cm.execCommand("delCharBefore");
              _cm.execCommand("delCharBefore");
              if (_cm.getValue().length === 0) {
                var pos = view.state.selection.$from.before();
                var end = view.state.selection.$from.after();
                view.dispatch(view.state.tr.delete(pos, end));
                view.focus();
              } else if (prosemirrorCommands.exitCode(view.state, view.dispatch)) {
                view.focus();
              }
              return;
            }
          }
        }
        _cm.execCommand("newlineAndIndent");
      }, _a.Backspace = function() {
        var _cm = cm();
        if (removeEmptyCodeBlock(view, _cm)) {
          view.focus();
        } else {
          _cm.execCommand("delCharBefore");
        }
      }, _a));
    };
    CodeBlockView2.prototype.maybeEscape = function(unit, dir) {
      var pos = this.cm.getCursor();
      if (this.cm.somethingSelected() || pos.line !== (dir < 0 ? this.cm.firstLine() : this.cm.lastLine()) || unit === "char" && pos.ch !== (dir < 0 ? 0 : this.cm.getLine(pos.line).length)) {
        return CodeMirror__default["default"].Pass;
      }
      this.view.focus();
      var targetPos = this.getPos() + (dir < 0 ? 0 : this.node.nodeSize);
      var selection = prosemirrorState.Selection.near(this.view.state.doc.resolve(targetPos), dir);
      this.view.dispatch(this.view.state.tr.setSelection(selection).scrollIntoView());
      this.view.focus();
    };
    CodeBlockView2.prototype.updateTemplValue = function() {
      this.templ.innerHTML = '<pre language="' + this.node.attrs.language + '" code_block="true"><code>' + fixCodeString(this.cm.getValue()) + "</code></pre>";
    };
    CodeBlockView2.prototype.update = function(node) {
      if (node.type !== this.node.type)
        return false;
      this.node = node;
      var change = computeChange(this.cm.getValue(), node.textContent);
      if (change) {
        this.updating = true;
        this.cm.replaceRange(change.text, this.cm.posFromIndex(change.from), this.cm.posFromIndex(change.to));
        this.updating = true;
      }
      return true;
    };
    CodeBlockView2.prototype.selectNode = function() {
      this.cm.focus();
    };
    CodeBlockView2.prototype.stopEvent = function() {
      return true;
    };
    CodeBlockView2.prototype.destroy = function() {
      this.editor.off(adapter.EventChannel.LocalEvent.ON_CHANGE, this.checkEditable);
    };
    return CodeBlockView2;
  }();
  function computeChange(oldVal, newVal) {
    if (oldVal === newVal)
      return null;
    var start = 0;
    var oldEnd = oldVal.length;
    var newEnd = newVal.length;
    while (start < oldEnd && oldVal.charCodeAt(start) === newVal.charCodeAt(start)) {
      ++start;
    }
    while (oldEnd > start && newEnd > start && oldVal.charCodeAt(oldEnd - 1) === newVal.charCodeAt(newEnd - 1)) {
      oldEnd--;
      newEnd--;
    }
    return {
      from: start,
      to: oldEnd,
      text: newVal.slice(start, newEnd)
    };
  }
  var __extends$1 = function() {
    var extendStatics = function(d, b) {
      extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
        d2.__proto__ = b2;
      } || function(d2, b2) {
        for (var p in b2)
          if (Object.prototype.hasOwnProperty.call(b2, p))
            d2[p] = b2[p];
      };
      return extendStatics(d, b);
    };
    return function(d, b) {
      if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  }();
  var formatCodeDOMStructure = function(dom) {
    var codeTags = Array.prototype.slice.call(dom.querySelectorAll("code"));
    var spans = Array.prototype.slice.call(dom.querySelectorAll("span"));
    codeTags.forEach(function(code, idx) {
      if (idx === codeTags.length - 1)
        return;
      code.appendChild(document.createElement("br"));
    });
    spans.forEach(function(span) {
      if (/\u200B/.test(span.innerText)) {
        span.innerText = span.innerText.replace(/\u200B/g, "");
      }
    });
  };
  var arrowHandler = function(dir) {
    return function(editor, state, dispatch, view) {
      if (state.selection.empty && view.endOfTextblock(dir)) {
        var side = dir === "left" || dir === "up" ? -1 : 1;
        var $head = state.selection.$head;
        var nextPos = prosemirrorState.Selection.near(state.doc.resolve(side > 0 ? $head.after() : $head.before()), side);
        if (nextPos.$head && nextPos.$head.parent.type.name === "code_block") {
          dispatch(state.tr.setSelection(nextPos));
          return true;
        }
      }
      return false;
    };
  };
  var CodeBlock = function(_super) {
    __extends$1(CodeBlock2, _super);
    function CodeBlock2() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.name = "code_block";
      _this.tagName = function() {
        return "pre";
      };
      _this.code = true;
      _this.notLastLine = true;
      _this.marks = "";
      _this.attrs = {
        language: {
          default: DEFAULT_LANGUAGE
        }
      };
      _this.textMatcher = [
        {
          matcher: /^```([^\s]*)\s$/,
          handler: function(match) {
            return {
              language: transformToShow(match[1])
            };
          }
        },
        {
          matcher: /^```([^\s]*)$/,
          timing: "enter",
          handler: function(match) {
            return {
              language: transformToShow(match[1])
            };
          }
        }
      ];
      _this.content = "text*";
      _this.parseDOM = [
        {
          tag: "pre",
          preserveWhitespace: "full",
          getAttrs: function(dom) {
            var parentElement = dom.parentElement;
            if (!parentElement || !parentElement.classList.contains("code-snippet__js")) {
              formatCodeDOMStructure(dom);
            }
            if (dom.querySelector(".ace-line")) {
              var lastBr = Array.prototype.slice.call(dom.querySelectorAll("br")).pop();
              if (lastBr && lastBr.parentElement) {
                lastBr.parentElement.removeChild(lastBr);
              }
            }
            var lineDOM = dom.querySelector(".line-numbers-rows");
            if (lineDOM && lineDOM.previousSibling && lineDOM.previousSibling.textContent === "\n" && lineDOM.parentElement) {
              lineDOM.parentElement.removeChild(lineDOM.previousSibling);
            }
            return getAttrs(dom);
          }
        },
        {
          tag: "div.CodeMirror",
          preserveWhitespace: "full",
          getAttrs: function(dom) {
            var preTags = Array.prototype.slice.call(dom.querySelectorAll("pre"));
            var orderDOMs = Array.prototype.slice.call(dom.querySelectorAll(".CodeMirror-linenumber"));
            preTags.forEach(function(pre, idx) {
              if (idx === preTags.length - 1)
                return;
              pre.appendChild(document.createTextNode("br"));
            });
            orderDOMs.forEach(function(_dom) {
              if (_dom.parentElement) {
                _dom.parentElement.removeChild(_dom);
              }
            });
            return getAttrs(dom);
          }
        },
        {
          tag: "p[code_block]",
          preserveWhitespace: "full",
          getAttrs
        },
        {
          tag: "section.code-snippet__js",
          preserveWhitespace: "full",
          getAttrs: function(dom) {
            var preDOM = dom.querySelector("pre");
            if (!preDOM)
              return false;
            var orderDOM = dom.querySelector("ul");
            if (orderDOM)
              dom.removeChild(orderDOM);
            formatCodeDOMStructure(dom);
            return getAttrs(preDOM);
          }
        }
      ];
      _this.defining = true;
      _this.NodeView = CodeBlockView;
      _this.toDOM = function(node) {
        return ["pre", { language: node.attrs.language, code_block: true }, ["code", 0]];
      };
      return _this;
    }
    CodeBlock2.keymap = {
      ArrowLeft: arrowHandler("left"),
      ArrowRight: arrowHandler("right"),
      ArrowUp: arrowHandler("up"),
      ArrowDown: arrowHandler("down")
    };
    return CodeBlock2;
  }(adapter.Block);
  function getAttrs(dom) {
    var language = dom.getAttribute("language");
    if (!language) {
      var wrapper = dom.querySelector("[language]");
      language = wrapper && wrapper.getAttribute("language") || DEFAULT_LANGUAGE;
    }
    return {
      language: transformToShow(language)
    };
  }
  var __extends = function() {
    var extendStatics = function(d, b) {
      extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
        d2.__proto__ = b2;
      } || function(d2, b2) {
        for (var p in b2)
          if (Object.prototype.hasOwnProperty.call(b2, p))
            d2[p] = b2[p];
      };
      return extendStatics(d, b);
    };
    return function(d, b) {
      if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  }();
  (function(_super) {
    __extends(CodeBlockPlugin, _super);
    function CodeBlockPlugin() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.name = PLUGIN_NAME;
      _this.Controller = CodeBlockController;
      _this.Schema = CodeBlock;
      return _this;
    }
    return CodeBlockPlugin;
  })(adapter.SylPlugin);
});
//# sourceMappingURL=index.js.map
